"use strict";
import { util } from '../../../util/util.js'
import { fullMap } from '../../../fullMap.js';
import { khcAlert } from '../../../component/alert/khcAlert.js'
let formComponent=null;
let functionMap=new Map();// 使用 Map 来存储多个函数。每个函数都通过 set 方法添加到 Map 中，键是函数名，值是对应的函数。
export function main(jsonConfig) {
    try {
        functionMap.get(jsonConfig.button_method).apply(jsonConfig);
    } catch (error) {
        khcAlert.showSystemError(error.message);
        console.log(error);
    }
}

function fCreate() {
    let jsonConfig=this;
    jsonConfig.formType='create'
    init.call(jsonConfig)
}
functionMap.set('fCreate', fCreate);// 将函数添加到 Map 中

function fEdit() {
    let jsonConfig=this;
    jsonConfig.formType='edit'
    init.call(jsonConfig)
}
functionMap.set('fEdit', fEdit);// 将函数添加到 Map 中

function fEchartsCreate(){
    let jsonConfig=this;
    jsonConfig.formType='create'
    init.call(jsonConfig)
}
functionMap.set('fEchartsCreate', fEchartsCreate);// 将函数添加到 Map 中

function fEchartsEdit(){
    let jsonConfig=this;
    jsonConfig.formType='edit'
    init.call(jsonConfig)
}
functionMap.set('fEchartsEdit', fEchartsEdit);// 将函数添加到 Map 中

function fDetail() {
    let jsonConfig=this;
    jsonConfig.formType='detail'
    init.call(jsonConfig)
}
functionMap.set('fDetail', fDetail);// 将函数添加到 Map 中

let initChartsDataTypeTypeFunc=null;//数据获取方式
let initIsRadioButtonTypeTypeFunc=null;//是否启用radio按钮
function init(){
    let jsonConfig=this;
    let objID = jsonConfig.objID;
    let formType = jsonConfig.formType
    formComponent = fullMap.getObj(objID);
    let eleMap=formComponent.getFormMap();
    if((formType==undefined||formType=='undefined')||formType=='create'){
        formComponent.initEleConfig({fieldArray:['d_json','d_sql','my_action_class','method_name','radio_dict','radio_default_value'],isDisabled:true,isClearValue:true,isShowDiv:false,isCanNull:false})
    }else if(formType=='edit'){
        initForm(eleMap)//初始化表单的一些限制,或对更改内容添加标注（添加背景颜色代表该字段被更改过）
        if(eleMap.get('charts_data_type').getValue()=='1'){
            formComponent.initEleConfig({fieldArray:['d_json'],isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
            formComponent.initEleConfig({fieldArray:['d_sql','my_action_class','method_name'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }else if(eleMap.get('charts_data_type').getValue()=='2'){
            formComponent.initEleConfig({fieldArray:['d_sql'],isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
            formComponent.initEleConfig({fieldArray:['d_json','my_action_class','method_name'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }else if(eleMap.get('charts_data_type').getValue()=='3'){
            formComponent.initEleConfig({fieldArray:['my_action_class','method_name'],isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
            formComponent.initEleConfig({fieldArray:['d_json','d_sql'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }else{
            formComponent.initEleConfig({fieldArray:['d_json','d_sql','my_action_class','method_name'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }
        if(eleMap.get('is_radio_button').getValue()=='Y'){
            formComponent.initEleConfig({fieldArray:['radio_dict','radio_default_value'],isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
        }else{
            formComponent.initEleConfig({fieldArray:['radio_dict','radio_default_value'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }
    }
    if(initChartsDataTypeTypeFunc!=null){
        document.getElementById(eleMap.get('charts_data_type').getEleID()).removeEventListener('change', initChartsDataTypeTypeFunc);
    }
    if(initChartsDataTypeTypeFunc!=null){
        document.getElementById(eleMap.get('is_radio_button').getEleID()).removeEventListener('change', initIsRadioButtonTypeTypeFunc);
    }
    initChartsDataTypeTypeFunc= function () {
        if(this.value=='1'){
            formComponent.initEleConfig({fieldArray:['d_json'],isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
            formComponent.initEleConfig({fieldArray:['d_sql','my_action_class','method_name'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }else if(this.value=='2'){
            formComponent.initEleConfig({fieldArray:['d_sql'],isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
            formComponent.initEleConfig({fieldArray:['d_json','my_action_class','method_name'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }else if(this.value=='3'){
            formComponent.initEleConfig({fieldArray:['my_action_class','method_name'],isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
            formComponent.initEleConfig({fieldArray:['d_json','d_sql'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }else{
            formComponent.initEleConfig({fieldArray:['d_json','d_sql','my_action_class','method_name'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }
    }
    initIsRadioButtonTypeTypeFunc= function () {
        if(this.value=='Y'){
            formComponent.initEleConfig({fieldArray:['radio_dict','radio_default_value'],isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
        }else{
            formComponent.initEleConfig({fieldArray:['radio_dict','radio_default_value'],isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})//隐藏
        }
    }

    //验证代码函数
    document.getElementById(eleMap.get('charts_data_type').getEleID()).addEventListener('change', initChartsDataTypeTypeFunc);
    document.getElementById(eleMap.get('is_radio_button').getEleID()).addEventListener('change', initIsRadioButtonTypeTypeFunc);
}
functionMap.set('init', init);// 将函数添加到 Map 中
function initForm(eleMap){
}



